diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/spectrum/model/three-gpp-channel-model.cc ns-3.42/src/spectrum/model/three-gpp-channel-model.cc
--- ns-3.41/src/spectrum/model/three-gpp-channel-model.cc	2024-02-09 14:44:08.497794400 -0800
+++ ns-3.42/src/spectrum/model/three-gpp-channel-model.cc	2024-05-29 15:29:47.172073600 -0700
@@ -1087,6 +2460,21 @@
     return channelParams->m_generatedTime > channelMatrix->m_generatedTime;
 }
 
+bool
+ThreeGppChannelModel::AntennaSetupChanged(Ptr<const PhasedArrayModel> aAntenna,
+                                          Ptr<const PhasedArrayModel> bAntenna,
+                                          Ptr<const ChannelMatrix> channelMatrix)
+{
+    // This allows changing the number of antenna ports during execution,
+    // which is used by nr's initial association.
+    size_t sAntNumElems = aAntenna->GetNumElems();
+    size_t uAntNumElems = bAntenna->GetNumElems();
+    size_t chanNumRows = channelMatrix->m_channel.GetNumRows();
+    size_t chanNumCols = channelMatrix->m_channel.GetNumCols();
+    return ((uAntNumElems != chanNumRows) || (sAntNumElems != chanNumCols)) &&
+           ((uAntNumElems != chanNumCols) || (sAntNumElems != chanNumRows));
+}
+
 Ptr<const MatrixBasedChannelModel::ChannelMatrix>
 ThreeGppChannelModel::GetChannel(Ptr<const MobilityModel> aMob,
                                  Ptr<const MobilityModel> bMob,
@@ -1126,17 +2514,8 @@
         notFoundParams = true;
     }
 
-    double x = aMob->GetPosition().x - bMob->GetPosition().x;
-    double y = aMob->GetPosition().y - bMob->GetPosition().y;
-    double distance2D = sqrt(x * x + y * y);
-
-    // NOTE we assume hUT = min (height(a), height(b)) and
-    // hBS = max (height (a), height (b))
-    double hUt = std::min(aMob->GetPosition().z, bMob->GetPosition().z);
-    double hBs = std::max(aMob->GetPosition().z, bMob->GetPosition().z);
-
     // get the 3GPP parameters
-    Ptr<const ParamsTable> table3gpp = GetThreeGppTable(condition, hBs, hUt, distance2D);
+    Ptr<const ParamsTable> table3gpp = GetThreeGppTable(aMob, bMob, condition);
 
     if (notFoundParams || updateParams)
     {
@@ -1159,6 +2538,7 @@
         NS_LOG_DEBUG("channel matrix present in the map");
         channelMatrix = m_channelMatrixMap[channelMatrixKey];
         updateMatrix = ChannelMatrixNeedsUpdate(channelParams, channelMatrix);
+        updateMatrix |= AntennaSetupChanged(aAntenna, bAntenna, channelMatrix);
     }
     else
     {
@@ -1391,8 +2771,15 @@
     double cNlos;
     // According to table 7.5-6, only cluster number equals to 8, 10, 11, 12, 19 and 20 is valid.
     // Not sure why the other cases are in Table 7.5-2.
+    // Added case 2 and 3 for the NTN according to table 6.7.2-1aa (28.811)
     switch (table3gpp->m_numOfCluster) // Table 7.5-2
     {
+    case 2:
+        cNlos = 0.501;
+        break;
+    case 3:
+        cNlos = 0.680;
+        break;
     case 4:
         cNlos = 0.779;
         break;
@@ -1438,8 +2825,18 @@
                  1e-4 * pow(kFactor, 3)); //(7.5-10))
     }
 
+    // Added case 2, 3 and 4 for the NTN according to table 6.7.2-1ab (28.811)
     switch (table3gpp->m_numOfCluster) // Table 7.5-4
     {
+    case 2:
+        cNlos = 0.430;
+        break;
+    case 3:
+        cNlos = 0.594;
+        break;
+    case 4:
+        cNlos = 0.697;
+        break;
     case 8:
         cNlos = 0.889;
         break;
@@ -1631,6 +3028,7 @@
         DoubleVector(table3gpp->m_raysPerCluster,
                      0)); // rayZodRadian[n][m], where n is cluster index, m is ray index
 
+    const double pow10_uLgZSD = pow(10, table3gpp->m_uLgZSD);
     for (uint8_t nInd = 0; nInd < channelParams->m_reducedClusterNumber; nInd++)
     {
         for (uint8_t mInd = 0; mInd < table3gpp->m_raysPerCluster; mInd++)
@@ -1640,9 +3038,8 @@
             std::tie(rayAoaRadian[nInd][mInd], rayZoaRadian[nInd][mInd]) =
                 WrapAngles(DegreesToRadians(tempAoa), DegreesToRadians(tempZoa));
 
-            double tempAod = clusterAod[nInd] + table3gpp->m_cASD * offSetAlpha[mInd]; //(7.5-13)
-            double tempZod = clusterZod[nInd] +
-                             0.375 * pow(10, table3gpp->m_uLgZSD) * offSetAlpha[mInd]; //(7.5-20)
+            double tempAod = clusterAod[nInd] + table3gpp->m_cASD * offSetAlpha[mInd];    //(7.5-13)
+            double tempZod = clusterZod[nInd] + 0.375 * pow10_uLgZSD * offSetAlpha[mInd]; //(7.5-20)
             std::tie(rayAodRadian[nInd][mInd], rayZodRadian[nInd][mInd]) =
                 WrapAngles(DegreesToRadians(tempAod), DegreesToRadians(tempZod));
         }
@@ -1664,34 +3061,35 @@
 
     // Step 9: Generate the cross polarization power ratios
     // Step 10: Draw initial phases
-    Double2DVector crossPolarizationPowerRatios; // vector containing the cross polarization power
-                                                 // ratios, as defined by 7.5-21
-    Double3DVector clusterPhase; // rayAoaRadian[n][m], where n is cluster index, m is ray index
+
+    // vector containing the cross polarization power ratios, as defined by 7.5-21
+    auto& crossPolarizationPowerRatios = channelParams->m_crossPolarizationPowerRatios;
+    // rayAoaRadian[n][m], where n is cluster index, m is ray index
+    auto& clusterPhase = channelParams->m_clusterPhase;
+
+    const double uXprLinear = pow(10, table3gpp->m_uXpr / 10.0);     // convert to linear
+    const double sigXprLinear = pow(10, table3gpp->m_sigXpr / 10.0); // convert to linear
+
+    // store the PHI values for all the possible combination of polarization
+    clusterPhase.resize(channelParams->m_reducedClusterNumber);
+    crossPolarizationPowerRatios.resize(channelParams->m_reducedClusterNumber);
     for (uint8_t nInd = 0; nInd < channelParams->m_reducedClusterNumber; nInd++)
     {
-        DoubleVector temp; // used to store the XPR values
-        Double2DVector
-            temp2; // used to store the PHI values for all the possible combination of polarization
+        clusterPhase[nInd].resize(table3gpp->m_raysPerCluster);
+        crossPolarizationPowerRatios[nInd].resize(table3gpp->m_raysPerCluster);
         for (uint8_t mInd = 0; mInd < table3gpp->m_raysPerCluster; mInd++)
         {
-            double uXprLinear = pow(10, table3gpp->m_uXpr / 10.0);     // convert to linear
-            double sigXprLinear = pow(10, table3gpp->m_sigXpr / 10.0); // convert to linear
-
-            temp.push_back(
-                std::pow(10, (m_normalRv->GetValue() * sigXprLinear + uXprLinear) / 10.0));
-            DoubleVector temp3; // used to store the PHI values
+            clusterPhase[nInd][mInd].resize(4);
+            // used to store the XPR values
+            crossPolarizationPowerRatios[nInd][mInd] =
+                std::pow(10, (m_normalRv->GetValue() * sigXprLinear + uXprLinear) / 10.0);
             for (uint8_t pInd = 0; pInd < 4; pInd++)
             {
-                temp3.push_back(m_uniformRv->GetValue(-1 * M_PI, M_PI));
+                // used to store the PHI values
+                clusterPhase[nInd][mInd][pInd] = m_uniformRv->GetValue(-1 * M_PI, M_PI);
             }
-            temp2.push_back(temp3);
         }
-        crossPolarizationPowerRatios.push_back(temp);
-        clusterPhase.push_back(temp2);
     }
-    // store the cluster phase
-    channelParams->m_clusterPhase = clusterPhase;
-    channelParams->m_crossPolarizationPowerRatios = crossPolarizationPowerRatios;
 
     uint8_t cluster1st = 0;
     uint8_t cluster2nd = 0; // first and second strongest cluster;
@@ -1784,6 +3182,20 @@
     channelParams->m_angle.push_back(clusterAod);
     channelParams->m_angle.push_back(clusterZod);
 
+    // Precompute angles sincos
+    channelParams->m_cachedAngleSincos.resize(channelParams->m_angle.size());
+    for (size_t direction = 0; direction < channelParams->m_angle.size(); direction++)
+    {
+        channelParams->m_cachedAngleSincos[direction].resize(
+            channelParams->m_angle[direction].size());
+        for (size_t cluster = 0; cluster < channelParams->m_angle[direction].size(); cluster++)
+        {
+            channelParams->m_cachedAngleSincos[direction][cluster] = {
+                sin(channelParams->m_angle[direction][cluster] * DEG2RAD),
+                cos(channelParams->m_angle[direction][cluster] * DEG2RAD)};
+        }
+    }
+
     // Compute alpha and D as described in 3GPP TR 37.885 v15.3.0, Sec. 6.2.3
     // These terms account for an additional Doppler contribution due to the
     // presence of moving objects in the surrounding environment, such as in
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/spectrum/model/three-gpp-channel-model.h ns-3.42/src/spectrum/model/three-gpp-channel-model.h
--- ns-3.41/src/spectrum/model/three-gpp-channel-model.h	2024-02-09 14:44:08.497794400 -0800
+++ ns-3.42/src/spectrum/model/three-gpp-channel-model.h	2024-05-29 15:29:47.172073600 -0700
@@ -24,6 +24,7 @@
 #include "matrix-based-channel-model.h"
 
 #include "ns3/angles.h"
+#include "ns3/deprecated.h"
 #include <ns3/boolean.h>
 #include <ns3/channel-condition-model.h>
 
@@ -250,11 +251,27 @@
      * \param hUT the height of the UT
      * \param distance2D the 2D distance between tx and rx
      * \return the parameters table
+     * \deprecated Use GetThreeGppTable(const Ptr<const MobilityModel> aMob, const Ptr<const
+     *  MobilityModel> bMob, Ptr<const ChannelCondition> channelCondition) instead
      */
-    virtual Ptr<const ParamsTable> GetThreeGppTable(Ptr<const ChannelCondition> channelCondition,
-                                                    double hBS,
-                                                    double hUT,
-                                                    double distance2D) const;
+    NS_DEPRECATED_3_41("Use GetThreeGppTable(const Ptr<const MobilityModel>, const Ptr<const "
+                       "MobilityModel>, Ptr<const ChannelCondition>) instead")
+    Ptr<const ParamsTable> GetThreeGppTable(Ptr<const ChannelCondition> channelCondition,
+                                            double hBS,
+                                            double hUT,
+                                            double distance2D) const;
+
+    /**
+     * Get the parameters needed to apply the channel generation procedure
+     * \param aMob the mobility model of node A
+     * \param bMob the mobility model of node B
+     * \param channelCondition the channel condition
+     * \return the parameters table
+     */
+    virtual Ptr<const ParamsTable> GetThreeGppTable(
+        const Ptr<const MobilityModel> aMob,
+        const Ptr<const MobilityModel> bMob,
+        Ptr<const ChannelCondition> channelCondition) const;
 
     /**
      * Prepare 3gpp channel parameters among the nodes a and b.
@@ -335,6 +352,18 @@
     bool ChannelMatrixNeedsUpdate(Ptr<const ThreeGppChannelParams> channelParams,
                                   Ptr<const ChannelMatrix> channelMatrix);
 
+    /**
+     * Check if the channel matrix has to be updated due to
+     * changes in the number of antenna ports
+     * \param aAntenna the antenna array of node a
+     * \param bAntenna the antenna array of node b
+     * \param channelMatrix channel matrix structure
+     * \return true if the channel matrix has to be updated, false otherwise
+     */
+    bool AntennaSetupChanged(Ptr<const PhasedArrayModel> aAntenna,
+                             Ptr<const PhasedArrayModel> bAntenna,
+                             Ptr<const ChannelMatrix> channelMatrix);
+
     std::unordered_map<uint64_t, Ptr<ChannelMatrix>>
         m_channelMatrixMap; //!< map containing the channel realizations per pair of
                             //!< PhasedAntennaArray instances, the key of this map is reciprocal
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/spectrum/model/three-gpp-spectrum-propagation-loss-model.cc ns-3.42/src/spectrum/model/three-gpp-spectrum-propagation-loss-model.cc
--- ns-3.41/src/spectrum/model/three-gpp-spectrum-propagation-loss-model.cc	2024-02-09 14:44:08.497794400 -0800
+++ ns-3.42/src/spectrum/model/three-gpp-spectrum-propagation-loss-model.cc	2024-05-29 15:29:47.172073600 -0700
@@ -175,6 +175,8 @@
     // as described in Section 5.2.2 of 3GPP TR 36.897,
     // and so equal beam weights are used for all the ports.
     // Support of the full-connection model for TXRU virtualization would need extensions.
+    const auto uElemsPerPort = uAnt->GetHElemsPerPort();
+    const auto sElemsPerPort = sAnt->GetHElemsPerPort();
     for (size_t tIndex = 0; tIndex < sPortElems; tIndex++, sIndex++)
     {
         std::complex<double> rxSum(0, 0);
@@ -182,21 +184,21 @@
         for (size_t rIndex = 0; rIndex < uPortElems; rIndex++, uIndex++)
         {
             rxSum += uW[uIndex - startU] * params->m_channel(uIndex, sIndex, cIndex);
-            auto testV = (rIndex % uAnt->GetHElemsPerPort());
-            auto ptInc = uAnt->GetHElemsPerPort() - 1;
+            auto testV = (rIndex % uElemsPerPort);
+            auto ptInc = uElemsPerPort - 1;
             if (testV == ptInc)
             {
-                auto incVal = uAnt->GetNumColumns() - uAnt->GetHElemsPerPort();
+                auto incVal = uAnt->GetNumColumns() - uElemsPerPort;
                 uIndex += incVal; // Increment by a factor to reach next column in a port
             }
         }
 
         txSum += sW[sIndex - startS] * rxSum;
-        auto testV = (tIndex % sAnt->GetHElemsPerPort());
-        auto ptInc = sAnt->GetHElemsPerPort() - 1;
+        auto testV = (tIndex % sElemsPerPort);
+        auto ptInc = sElemsPerPort - 1;
         if (testV == ptInc)
         {
-            size_t incVal = sAnt->GetNumColumns() - sAnt->GetHElemsPerPort();
+            size_t incVal = sAnt->GetNumColumns() - sElemsPerPort;
             sIndex += incVal; // Increment by a factor to reach next column in a port
         }
     }
@@ -237,31 +239,19 @@
     NS_ASSERT(numCluster <= longTerm->GetNumPages());
 
     // check if channelParams structure is generated in direction s-to-u or u-to-s
-    bool isSameDirection = (channelParams->m_nodeIds == channelMatrix->m_nodeIds);
-
-    MatrixBasedChannelModel::DoubleVector zoa;
-    MatrixBasedChannelModel::DoubleVector zod;
-    MatrixBasedChannelModel::DoubleVector aoa;
-    MatrixBasedChannelModel::DoubleVector aod;
+    bool isSameDir = (channelParams->m_nodeIds == channelMatrix->m_nodeIds);
 
     // if channel params is generated in the same direction in which we
     // generate the channel matrix, angles and zenith of departure and arrival are ok,
     // just set them to corresponding variable that will be used for the generation
     // of channel matrix, otherwise we need to flip angles and zeniths of departure and arrival
-    if (isSameDirection)
-    {
-        zoa = channelParams->m_angle[MatrixBasedChannelModel::ZOA_INDEX];
-        zod = channelParams->m_angle[MatrixBasedChannelModel::ZOD_INDEX];
-        aoa = channelParams->m_angle[MatrixBasedChannelModel::AOA_INDEX];
-        aod = channelParams->m_angle[MatrixBasedChannelModel::AOD_INDEX];
-    }
-    else
-    {
-        zod = channelParams->m_angle[MatrixBasedChannelModel::ZOA_INDEX];
-        zoa = channelParams->m_angle[MatrixBasedChannelModel::ZOD_INDEX];
-        aod = channelParams->m_angle[MatrixBasedChannelModel::AOA_INDEX];
-        aoa = channelParams->m_angle[MatrixBasedChannelModel::AOD_INDEX];
-    }
+    using DPV = std::vector<std::pair<double, double>>;
+    using MBCM = MatrixBasedChannelModel;
+    const auto& cachedAngleSincos = channelParams->m_cachedAngleSincos;
+    const DPV& zoa = cachedAngleSincos[isSameDir ? MBCM::ZOA_INDEX : MBCM::ZOD_INDEX];
+    const DPV& zod = cachedAngleSincos[isSameDir ? MBCM::ZOD_INDEX : MBCM::ZOA_INDEX];
+    const DPV& aoa = cachedAngleSincos[isSameDir ? MBCM::AOA_INDEX : MBCM::AOD_INDEX];
+    const DPV& aod = cachedAngleSincos[isSameDir ? MBCM::AOD_INDEX : MBCM::AOA_INDEX];
 
     for (size_t cIndex = 0; cIndex < numCluster; cIndex++)
     {
@@ -281,13 +271,12 @@
 
         // cluster angle angle[direction][n], where direction = 0(aoa), 1(zoa).
         double tempDoppler =
-            factor * ((sin(zoa[cIndex] * M_PI / 180) * cos(aoa[cIndex] * M_PI / 180) * uSpeed.x +
-                       sin(zoa[cIndex] * M_PI / 180) * sin(aoa[cIndex] * M_PI / 180) * uSpeed.y +
-                       cos(zoa[cIndex] * M_PI / 180) * uSpeed.z) +
-                      (sin(zod[cIndex] * M_PI / 180) * cos(aod[cIndex] * M_PI / 180) * sSpeed.x +
-                       sin(zod[cIndex] * M_PI / 180) * sin(aod[cIndex] * M_PI / 180) * sSpeed.y +
-                       cos(zod[cIndex] * M_PI / 180) * sSpeed.z) +
-                      2 * alpha * D);
+            factor *
+            ((zoa[cIndex].first * aoa[cIndex].second * uSpeed.x +
+              zoa[cIndex].first * aoa[cIndex].first * uSpeed.y + zoa[cIndex].second * uSpeed.z) +
+             (zod[cIndex].first * aod[cIndex].second * sSpeed.x +
+              zod[cIndex].first * aod[cIndex].first * sSpeed.y + zod[cIndex].second * sSpeed.z) +
+             2 * alpha * D);
         doppler[cIndex] = std::complex<double>(cos(tempDoppler), sin(tempDoppler));
     }
 
@@ -368,40 +357,70 @@
     Ptr<MatrixBasedChannelModel::Complex3DVector> chanSpct =
         Create<MatrixBasedChannelModel::Complex3DVector>(numRxPorts, numTxPorts, (uint16_t)numRb);
 
+    // Precompute the delay until numRb, numCluster or RB width changes
+    // Whenever the channelParams is updated, the number of numRbs, numClusters
+    // and RB width (12*SCS) are reset, ensuring these values are updated too
+    double rbWidth = inPsd->ConstBandsBegin()->fh - inPsd->ConstBandsBegin()->fl;
+
+    if (channelParams->m_cachedDelaySincos.GetNumRows() != numRb ||
+        channelParams->m_cachedDelaySincos.GetNumCols() != numCluster ||
+        channelParams->m_cachedRbWidth != rbWidth)
+    {
+        channelParams->m_cachedRbWidth = rbWidth;
+        channelParams->m_cachedDelaySincos = ComplexMatrixArray(numRb, numCluster);
+        auto sbit = inPsd->ConstBandsBegin(); // band iterator
+        for (unsigned i = 0; i < numRb; i++)
+        {
+            double fsb = (*sbit).fc; // center frequency of the sub-band
+            for (std::size_t cIndex = 0; cIndex < numCluster; cIndex++)
+            {
+                double delay = -2 * M_PI * fsb * (channelParams->m_delay[cIndex]);
+                channelParams->m_cachedDelaySincos(i, cIndex) =
+                    std::complex<double>(cos(delay), sin(delay));
+            }
+            sbit++;
+        }
+    }
+
+    // Compute the product between the doppler and the delay sincos
+    auto delaySincosCopy = channelParams->m_cachedDelaySincos;
+    for (size_t iRb = 0; iRb < inPsd->GetValuesN(); iRb++)
+    {
+        for (std::size_t cIndex = 0; cIndex < numCluster; cIndex++)
+        {
+            delaySincosCopy(iRb, cIndex) *= doppler[cIndex];
+        }
+    }
+
     // If "params" (ChannelMatrix) and longTerm were computed for the reverse direction (e.g. this
     // is a DL transmission but params and longTerm were last updated during UL), then the elements
     // in longTerm start from different offsets.
 
-    auto vit = inPsd->ValuesBegin();      // psd iterator
-    auto sbit = inPsd->ConstBandsBegin(); // band iterator
+    auto vit = inPsd->ValuesBegin(); // psd iterator
     size_t iRb = 0;
     // Compute the frequency-domain channel matrix
     while (vit != inPsd->ValuesEnd())
     {
         if ((*vit) != 0.00)
         {
-            double fsb = (*sbit).fc; // center frequency of the sub-band
+            auto sqrtVit = sqrt(*vit);
             for (auto rxPortIdx = 0; rxPortIdx < numRxPorts; rxPortIdx++)
             {
                 for (auto txPortIdx = 0; txPortIdx < numTxPorts; txPortIdx++)
                 {
                     std::complex<double> subsbandGain(0.0, 0.0);
-
                     for (size_t cIndex = 0; cIndex < numCluster; cIndex++)
                     {
-                        double delay = -2 * M_PI * fsb * (channelParams->m_delay[cIndex]);
                         subsbandGain += directionalLongTerm(rxPortIdx, txPortIdx, cIndex) *
-                                        doppler[cIndex] *
-                                        std::complex<double>(cos(delay), sin(delay));
+                                        delaySincosCopy(iRb, cIndex);
                     }
                     // Multiply with the square root of the input PSD so that the norm (absolute
                     // value squared) of chanSpct will be the output PSD
-                    chanSpct->Elem(rxPortIdx, txPortIdx, iRb) = sqrt(*vit) * subsbandGain;
+                    chanSpct->Elem(rxPortIdx, txPortIdx, iRb) = sqrtVit * subsbandGain;
                 }
             }
         }
         vit++;
-        sbit++;
         iRb++;
     }
     return chanSpct;
@@ -492,10 +511,6 @@
     NS_LOG_FUNCTION(this << spectrumSignalParams << a << b << aPhasedArrayModel
                          << bPhasedArrayModel);
 
-    if (a->GetPosition() == b->GetPosition())
-    {
-        return spectrumSignalParams->Copy();
-    }
     uint32_t aId = a->GetObject<Node>()->GetId(); // id of the node a
     uint32_t bId = b->GetObject<Node>()->GetId(); // id of the node b
     NS_ASSERT_MSG(aPhasedArrayModel, "Antenna not found for node " << aId);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/spectrum/model/tv-spectrum-transmitter.cc ns-3.42/src/spectrum/model/tv-spectrum-transmitter.cc
--- ns-3.41/src/spectrum/model/tv-spectrum-transmitter.cc	2024-02-09 14:44:08.497794400 -0800
+++ ns-3.42/src/spectrum/model/tv-spectrum-transmitter.cc	2024-05-29 15:29:47.172073600 -0700
@@ -507,8 +507,6 @@
             case 82:
             case 83:
             case 84:
-                (*psd)[i] = 3.16228e-06 * basePsdWattsHz;
-                break;
             case 85:
             case 86:
             case 87:
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/spectrum/model/waveform-generator.cc ns-3.42/src/spectrum/model/waveform-generator.cc
--- ns-3.41/src/spectrum/model/waveform-generator.cc	2024-02-09 14:44:08.501794300 -0800
+++ ns-3.42/src/spectrum/model/waveform-generator.cc	2024-05-29 15:29:47.172073600 -0700
@@ -53,7 +53,7 @@
     m_channel = nullptr;
     m_netDevice = nullptr;
     m_mobility = nullptr;
-    if (m_nextWave.IsRunning())
+    if (m_nextWave.IsPending())
     {
         m_nextWave.Cancel();
     }
@@ -202,7 +202,7 @@
 WaveformGenerator::Start()
 {
     NS_LOG_FUNCTION(this);
-    if (!m_nextWave.IsRunning())
+    if (!m_nextWave.IsPending())
     {
         NS_LOG_LOGIC("generator was not active, now starting");
         m_startTime = Now();
@@ -214,7 +214,7 @@
 WaveformGenerator::Stop()
 {
     NS_LOG_FUNCTION(this);
-    if (m_nextWave.IsRunning())
+    if (m_nextWave.IsPending())
     {
         m_nextWave.Cancel();
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/spectrum/test/spectrum-ideal-phy-test.cc ns-3.42/src/spectrum/test/spectrum-ideal-phy-test.cc
--- ns-3.41/src/spectrum/test/spectrum-ideal-phy-test.cc	2024-02-09 14:44:08.501794300 -0800
+++ ns-3.42/src/spectrum/test/spectrum-ideal-phy-test.cc	2024-05-29 15:29:47.172073600 -0700
@@ -240,7 +240,7 @@
 };
 
 SpectrumIdealPhyTestSuite::SpectrumIdealPhyTestSuite()
-    : TestSuite("spectrum-ideal-phy", SYSTEM)
+    : TestSuite("spectrum-ideal-phy", Type::SYSTEM)
 {
     NS_LOG_INFO("creating SpectrumIdealPhyTestSuite");
 
@@ -251,32 +251,32 @@
                                                  static_cast<uint64_t>(achievableRate * 0.1),
                                                  true,
                                                  "ns3::SingleModelSpectrumChannel"),
-                    TestCase::QUICK);
+                    TestCase::Duration::QUICK);
         AddTestCase(new SpectrumIdealPhyTestCase(snr,
                                                  static_cast<uint64_t>(achievableRate * 0.5),
                                                  true,
                                                  "ns3::SingleModelSpectrumChannel"),
-                    TestCase::QUICK);
+                    TestCase::Duration::QUICK);
         AddTestCase(new SpectrumIdealPhyTestCase(snr,
                                                  static_cast<uint64_t>(achievableRate * 0.95),
                                                  true,
                                                  "ns3::SingleModelSpectrumChannel"),
-                    TestCase::QUICK);
+                    TestCase::Duration::QUICK);
         AddTestCase(new SpectrumIdealPhyTestCase(snr,
                                                  static_cast<uint64_t>(achievableRate * 1.05),
                                                  false,
                                                  "ns3::SingleModelSpectrumChannel"),
-                    TestCase::QUICK);
+                    TestCase::Duration::QUICK);
         AddTestCase(new SpectrumIdealPhyTestCase(snr,
                                                  static_cast<uint64_t>(achievableRate * 2),
                                                  false,
                                                  "ns3::SingleModelSpectrumChannel"),
-                    TestCase::QUICK);
+                    TestCase::Duration::QUICK);
         AddTestCase(new SpectrumIdealPhyTestCase(snr,
                                                  static_cast<uint64_t>(achievableRate * 4),
                                                  false,
                                                  "ns3::SingleModelSpectrumChannel"),
-                    TestCase::QUICK);
+                    TestCase::Duration::QUICK);
     }
     for (double snr = 0.01; snr <= 10; snr *= 10)
     {
@@ -285,32 +285,32 @@
                                                  static_cast<uint64_t>(achievableRate * 0.1),
                                                  true,
                                                  "ns3::MultiModelSpectrumChannel"),
-                    TestCase::QUICK);
+                    TestCase::Duration::QUICK);
         AddTestCase(new SpectrumIdealPhyTestCase(snr,
                                                  static_cast<uint64_t>(achievableRate * 0.5),
                                                  true,
                                                  "ns3::MultiModelSpectrumChannel"),
-                    TestCase::QUICK);
+                    TestCase::Duration::QUICK);
         AddTestCase(new SpectrumIdealPhyTestCase(snr,
                                                  static_cast<uint64_t>(achievableRate * 0.95),
                                                  true,
                                                  "ns3::MultiModelSpectrumChannel"),
-                    TestCase::QUICK);
+                    TestCase::Duration::QUICK);
         AddTestCase(new SpectrumIdealPhyTestCase(snr,
                                                  static_cast<uint64_t>(achievableRate * 1.05),
                                                  false,
                                                  "ns3::MultiModelSpectrumChannel"),
-                    TestCase::QUICK);
+                    TestCase::Duration::QUICK);
         AddTestCase(new SpectrumIdealPhyTestCase(snr,
                                                  static_cast<uint64_t>(achievableRate * 2),
                                                  false,
                                                  "ns3::MultiModelSpectrumChannel"),
-                    TestCase::QUICK);
+                    TestCase::Duration::QUICK);
         AddTestCase(new SpectrumIdealPhyTestCase(snr,
                                                  static_cast<uint64_t>(achievableRate * 4),
                                                  false,
                                                  "ns3::MultiModelSpectrumChannel"),
-                    TestCase::QUICK);
+                    TestCase::Duration::QUICK);
     }
 }
 
